<?php

namespace App\Http\Controllers;

use App\Models\User;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Mail;
use Illuminate\Support\Facades\URL;
use Illuminate\Support\Str;
use SebastianBergmann\Diff\Exception;

class UserController extends Controller
{
    function index() {
        return view('user-form');
    }

    function store(Request $request) {
        try {
            $input = $request->all();
            $mobile_otp = rand( 1000 , 9999 );
            $email_otp = rand( 1000 , 9999 );
            $user = User::where('email',$input['email'])->first();
            if(!$user) {
                $user = new User();
            }
            $user->name = $input['name'];
            $user->mobile = $input['mobile'];
            $user->email = $input['email'];
            $user->remember_token = Str::random(60);
            $user->mobile_otp = $mobile_otp;
            $user->email_otp = $email_otp;
            $user->password = bcrypt(123456);;
            $user->save();


            $userData = User::where('email',$input['email'])->first()->toArray();
            $link = URL::to('/verify/email/'.$user->remember_token);
            $userData['link'] = $link;
         Mail::send('mail', ['userData' => $userData], function($message) use ($userData) {
            $message->to($userData['email']);
            $message->subject('Welcome Mail');
        });

        return redirect('verification-email')->with(['status'=> 'OTP sent successfully','user' => $user]);
        } catch (Exception $e) {
            return redirect()->back()->with('error', $e->getMessage());
        }
    }

    function verificationemail() {
        return view('verification-email');
    }

    function verifyemail(Request $request) {
        if (!$request->user_id) {
            return redirect('index')->with(['error'=> 'Session Out']);
        }
        $input = $request->all();
        $user = User::find($request->user_id);
        if ($user->email_otp != $request->email_otp) {
            return redirect()->back()->with(['error'=> 'Email Otp is not valid','user' => $user]);
        }
        return redirect('password')->with(['status'=> 'OTP Verified successfully to Mobile number and Email','user' => $user]);
    }

    function verifybyToken($token) {
        $user = User::where('remember_token', $token)->first();
        if ($user) {
            $user->email_verified_at = now();
            $user->save();
            return redirect('password')->with(['status'=> 'Email Verified Successfully','user' => $user]);
        }
        return redirect('index')->with(['error'=> 'Verification token is invalid'       ]);
    }

    function password() {
        return view('password');
    }

    function passwordSubmit(Request $request) {
        if (!$request->user_id) {
            return redirect('index')->with(['error'=> 'Session Out']);
        }
        $user = User::find($request->user_id);
        $user->password = bcrypt($request->password);


        \Telnyx\Telnyx::setApiKey('KEY018097A5E5BE2706201631ABD57B8600_Eo09LzaQB5j3s04axkeHG6');
        $resource = \Telnyx\VerifyProfile::create([
            "name" => $user->name,
            "default_timeout_secs" => 300
        ]);


        $curl = curl_init();

        curl_setopt_array($curl, array(
            CURLOPT_URL => "https://api.telnyx.com/v2/verifications/sms",
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 30000,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => "POST",
            CURLOPT_POSTFIELDS => '{"phone_number":"'.$user->mobile.'","verify_profile_id":"'.$resource['id'].'"}',
            CURLOPT_HTTPHEADER => array(
                // Set here requred headers
                "Content-Type: application/json",
                "Accept: application/json",
                "Authorization: Bearer KEY0180868652694575A85396A85654A9B8_nyvrHh1HRTZ5dVHJ0ZRFWh"
            ),
        ));

        $response = curl_exec($curl);
        $err = curl_error($curl);

        curl_close($curl);

        $user->sms_id = $resource['id'];
        $user->save();

        return redirect('verification-phone')->with(['status'=> 'OTP sent successfully','user' => $user]);
    }

    function verificationphone() {
        return view('verification-phone-form');
    }

    function verifyphone(Request $request) {
        $input = $request->all();
        if (!$request->user_id) {
            return redirect('index')->with(['error'=> 'Session Our']);
        }
        $user = User::find($request->user_id);
        $curl = curl_init();

        curl_setopt_array($curl, array(
            CURLOPT_URL => "https://api.telnyx.com/v2/verifications/by_phone_number/".$user->mobile."/actions/verify",
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 30000,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => "POST",
            CURLOPT_POSTFIELDS => '{"code":"'.$request->mobile_otp.'", "verify_profile_id": "'.$user->sms_id.'"}',
            CURLOPT_HTTPHEADER => array(
                // Set here requred headers
                "Content-Type: application/json",
                "Accept: application/json",
                "Authorization: Bearer KEY0180868652694575A85396A85654A9B8_nyvrHh1HRTZ5dVHJ0ZRFWh"
            ),
        ));

        $response = curl_exec($curl);
        $err = curl_error($curl);

        curl_close($curl);
        if(json_decode($response)->data->response_code == 'rejected') {
            return redirect('verification-phone')->with(['error'=> 'OTP Invalid','user' => $user]);
        }
        return redirect('verified')->with(['status'=> 'OTP Verified successfully','user' => $user]);
    }

    function verified() {
        return view('verified');
    }

    public function mail()
    {
        $user = User::first()->toArray();

        Mail::send('mail', $user, function($message) use ($user) {
            $message->to($user['email']);
            $message->subject('Welcome Mail');
        });
        dd('Mail Send Successfully');
    }
}
